'''
Created on 23 oct. 2012

@author: coissac
'''

from orgasm.tango import tango, \
                         matchtoseed, \
                         cutLowCoverage, \
                         scaffold, \
                         coverageEstimate, \
                         fillGaps, \
                         path2fasta
from orgasm.indexer import Index
from orgasm.backtranslate.fasta import fasta
from orgasm.assembler import Assembler
from orgasm.samples import protChloroArabidopsis
import sys
import pickle

#p = fasta('../../samples/arabidopsis.chloro.prot.fasta')

prefix="Coespi"
gp = ['rbcL','matK','ndhA',
      'rpoA','atpA','atpH',
      'rpoA','atpB','psbN',
      'psbT','psbB','psbD',
      'psbE','psbF','psbA',
      'psbC','psbM','psbI',
      'psbH','psbK','psbJ',
      'psbL','psbZ']

p2=dict(x for x in protChloroArabidopsis.items() if x[0] in gp)

r = Index('../../samples/'+prefix)
m = r.lookForSeeds(p2)
%ppickle.dump(m,open(prefix+'.match.omx',"w"))

s = matchtoseed(m,r)
asm = Assembler(r)
a = tango(asm,s,mincov=1,minread=10,minoverlap=40,maxjump=0,cycle=1)

asm.cleanDeadBranches(maxlength=10)

cutLowCoverage(asm,10,terminal=False)

score,length,coverage = coverageEstimate(asm)

cutLowCoverage(asm,int(coverage/3),terminal=False)

while fillGaps(asm,back=300,minread=10,maxjump=0,minoverlap=40,cmincov=2,gmincov=int(coverage/3)) > 0:
    pass

cg = asm.compactAssembling()
scaffold(asm,cg,minlink=4,back=400,addConnectedLink=False)

print >>open(prefix+'.clean.gml','w'),cg.gml()

fp = [4,6,-1,-2,-3,-6]
cg = asm.compactAssembling()
fa = path2fasta(asm,cg,fp,identifier=prefix,back=400,minlink=5)
print >>open(prefix+'.chloro.fasta','w'),fa


#################### cow mitochondrions ##################


from orgasm.tango import tango, \
                         matchtoseed, \
                         cutLowCoverage, \
                         scaffold, \
                         coverageEstimate, \
                         fillGaps, \
                         path2fasta
from orgasm.indexer import Index
from orgasm.backtranslate.fasta import fasta
from orgasm.assembler import Assembler
from orgasm.samples import protCox1Capra
import sys
import pickle
import glob


cows = [i.split('/')[-1].split('.')[0] for i in glob.glob("/Users/coissac/travail/NextGen/mito/bos-torus/*.ogx")]

for prefix in cows:
    r = Index('/Users/coissac/travail/NextGen/mito/bos-torus/%s' % prefix)
    m = r.lookForSeeds(protCox1Capra)
    
    s = matchtoseed(m,r)
    asm = Assembler(r)
    a = tango(asm,s,mincov=1,minread=4,minoverlap=27,maxjump=0,cycle=1)
    
    asm.cleanDeadBranches(maxlength=10)
    
    score,length,coverage = coverageEstimate(asm)
    
    while cutLowCoverage(asm,int(coverage/3),terminal=False):
        pass
    
    
    while fillGaps(asm,back=700,minread=4,maxjump=0,minoverlap=27,cmincov=0,gmincov=int(coverage/4)):
        pass
    
    cg = asm.compactAssembling()
    #scaffold(asm,cg,minlink=4,back=400,addConnectedLink=False)
    
    stems = [(i['length'],i['stemid']) for i in (cg.getEdgeAttr(*j) for j in cg.edgeIterator())]
    stems.sort(key=lambda i:i[0],reverse=True)
    
    fa = path2fasta(asm,cg,[stems[0][1]],identifier=prefix,back=400,minlink=5)
    print >>open(prefix+'.mito.fasta','w'),fa

##################################################################################
#
#   LA DESSOUS C'EST MON BORDEL
#
##################################################################################


    
    
x={'rpl14': [(2573766, 18, 2, 1, 0.0),
  (-3397517, 16, 3, -3, 0.0),
  (-9351610, 16, 2, -2, 0.0),
  (11206729, 16, 2, 1, 0.0),
  (-13075047, 16, 2, -2, 0.0),
  (14685869, 18, 2, 0, 0.0),
  (14999159, 17, 2, 0, 0.0)],
 'rpl16': [(-909221, 22, 3, -2, 0.0),
  (2094043, 17, 2, 2, 0.0),
  (-3759908, 19, 2, -2, 0.0),
  (-5946274, 17, 3, -3, 0.0),
  (8126977, 16, 2, 1, 0.0),
  (9588507, 21, 2, 1, 0.0),
  (10738816, 19, 3, 2, 0.0)],
 'rpl2': [(236866, 16, 2, 0, 0.0),
  (1928532, 16, 2, 0, 0.0),
  (5706417, 16, 10, 2, 0.0),
  (5782045, 16, 3, 1, 0.0),
  (8196126, 19, 2, 2, 0.0),
  (8244020, 19, 3, 2, 0.0),
  (-8296859, 19, 2, -2, 0.0),
  (-8298962, 18, 3, -2, 0.0),
  (-8535070, 19, 4, -3, 0.0),
  (8626832, 18, 3, 2, 0.0),
  (-9342483, 16, 2, -1, 0.0),
  (-9456051, 17, 2, -3, 0.0),
  (11173582, 16, 5, 2, 0.0),
  (-13132160, 19, 2, -2, 0.0),
  (-16455865, 17, 3, -3, 0.0),
  (16919446, 17, 2, 2, 0.0)],
 'rps12': [(862750, 18, 2, 1, 0.0),
  (-2207684, 17, 3, -2, 0.0),
  (-2745111, 18, 2, -1, 0.0),
  (4889605, 18, 2, 2, 0.0),
  (5064189, 16, 2, 2, 0.0),
  (5211803, 18, 2, 0, 0.0),
  (5254975, 17, 2, 2, 0.0),
  (-7094217, 20, 2, -3, 0.0),
  (7402069, 22, 2, 2, 0.09981524629190291),
  (-7464726, 17, 2, -3, 0.0),
  (-7881444, 17, 2, -3, 0.0),
  (7976243, 16, 3, 2, 0.0),
  (8431545, 19, 2, 1, 0.0),
  (8436186, 22, 4, 1, 0.09981524629190291),
  (10449608, 16, 5, 1, 0.0),
  (10524565, 17, 2, 0, 0.0),
  (-13424151, 18, 2, -2, 0.0),
  (-13495209, 16, 3, -1, 0.0),
  (15071790, 16, 2, 1, 0.0)],
 'rps2': [(62453, 16, 2, 2, 0.0),
  (160869, 16, 2, 1, 0.0),
  (412778, 18, 3, 1, 0.0),
  (-1151828, 18, 3, -1, 0.0),
  (1442154, 18, 4, 1, 0.0),
  (-2871339, 18, 3, -2, 0.0),
  (2918339, 18, 5, 2, 0.0),
  (3042383, 17, 4, 1, 0.0),
  (4342413, 18, 2, 0, 0.0),
  (-10087325, 16, 2, -2, 0.0),
  (-11357851, 18, 3, -2, 0.0),
  (11941870, 18, 4, 2, 0.0),
  (-13024299, 18, 2, -2, 0.0),
  (-13786786, 18, 4, -1, 0.0),
  (-14048126, 18, 2, -3, 0.0),
  (15505340, 18, 2, 2, 0.0),
  (16782797, 18, 2, 2, 0.0)],
 'rps4': [(564720, 17, 2, 1, 0.0),
  (-1176979, 19, 2, -1, 0.0),
  (-2960382, 17, 2, -2, 0.0),
  (7102274, 16, 2, 1, 0.0),
  (-8195121, 18, 2, -2, 0.0),
  (8371520, 16, 3, 1, 0.0),
  (-8517970, 17, 2, -2, 0.0),
  (-9898537, 17, 3, -3, 0.0),
  (11426723, 18, 3, 1, 0.0),
  (13103212, 19, 2, 2, 0.0),
  (-14729273, 16, 2, -2, 0.0)]}


def testIndex(r):
    from obitools import NucSequence
    from obitools.utils import progressBar as pb
    nbseq = len(r)
    rsize =  r.getReadSize()
    
    pb(1,nbseq,1)
    
    for i in xrange(1,nbseq+1):
        cseq = str(NucSequence('xxx',r.getRead(i,0,rsize)).complement()).upper()
        rseq = r.getRead(-i,0,rsize)
        pb(i,nbseq)
        if cseq!=rseq:
            print "problem with read : %d" %i
            print "   %s",cseq 
            print "   %s",rseq
            print
            
s=dict((r.getIds(y[0])[0],('rbcL',)) for y in x['rbcL'])
    
                  
    
     

def distPaired(x,p,index):
    dist = []
    lindex = len(index)
    i = p[x]
    pp = [index.getIds(index.getPairedRead(j))[0] for j in index.getIds(i)[2] if j <=lindex and j > 0]
    
    for j in pp:
        try:
            p1=p.index(j,x)
        except ValueError:
            p1=-1
            
        if p1 < 0:
            try:
                p1=p.index(-j,x)
            except ValueError:
                pass
        if p1 > 0:
            p1 = p1 - x   
            dist.append(p1) 
            
    return dist

p = cg.getEdgeAttr(27099517, 100005265, 0)['path']
d = reduce(lambda a,b:a+b,(distPaired(i,p,r) for i in range(len(p))))


def cutParallel(self,mincov):
    index = self.index
    stems = [x for x in self.stemIterator(alllink=False)]
    readSize = index.getReadSize()
    stemparallel ={}
    for first, last, lseq, sequence, path in stems:
        weight = sum(self.graph[x]['coverage'] for x in path if x in self.graph and 'coverage' in self.graph[x]) / float(len(path)) * readSize
        s = (first, last)
        ls = stemparallel.get(s,[])
        ls.append((first, last, lseq, sequence, path,weight))
        stemparallel[s]=ls
    spis = stemparallel.keys()
    for spi in spis:
        if len(stemparallel[spi]==1):
            del stemparallel[spi]
    return stemparallel
    

